/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#include <soprano/soprano.h>

#include "calendar.h"

#include "calendarscale.h"
#include "calendardataobject.h"

#include <QtCore/QDateTime>
#include <QtCore/QDate>
#include <QtCore/QTime>

NepomukFast::Calendar::Calendar( const QUrl &uri, const QUrl &graphUri )
  : InformationElement( uri, graphUri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#Calendar", QUrl::StrictMode) )
{
}

NepomukFast::Calendar::Calendar( const QUrl& uri, const QUrl& graphUri, const QUrl& type )
  : InformationElement( uri, graphUri, type )
{
}

void NepomukFast::Calendar::setComponents( const QList<NepomukFast::CalendarDataObject>& value )
{
    for( QList<CalendarDataObject>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#component"), (*it).uri() );
    }
}

void NepomukFast::Calendar::addComponent( const NepomukFast::CalendarDataObject& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#component"), value.uri() );
}

QUrl NepomukFast::Calendar::componentUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#component");
}

void NepomukFast::Calendar::setProdids( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#prodid"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::Calendar::addProdid( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#prodid"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::Calendar::prodidUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#prodid");
}

void NepomukFast::Calendar::setMethods( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#method"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::Calendar::addMethod( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#method"), Soprano::LiteralValue( value ) );
}

void NepomukFast::Calendar::setMethod( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#method"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::Calendar::methodUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#method");
}

void NepomukFast::Calendar::setCalscales( const QList<NepomukFast::CalendarScale>& value )
{
    for( QList<CalendarScale>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#calscale"), (*it).uri() );
    }
}

void NepomukFast::Calendar::addCalscale( const NepomukFast::CalendarScale& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#calscale"), value.uri() );
}

void NepomukFast::Calendar::setCalscale( const NepomukFast::CalendarScale& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#calscale"), value.uri() );
}

QUrl NepomukFast::Calendar::calscaleUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#calscale");
}

void NepomukFast::Calendar::setVersions( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#version"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::Calendar::addVersion( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#version"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::Calendar::versionUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#version");
}


