/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#include <soprano/soprano.h>

#include "informationelement.h"

#include "datasource.h"
#include "dataobject.h"
#include "informationelement.h"
#include "contact.h"

#include <QtCore/QDateTime>
#include <QtCore/QDate>
#include <QtCore/QTime>

NepomukFast::InformationElement::InformationElement( const QUrl &uri, const QUrl &graphUri )
  : NepomukFast::Resource( uri, graphUri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#InformationElement", QUrl::StrictMode) )
{
}

NepomukFast::InformationElement::InformationElement( const QUrl& uri, const QUrl& graphUri, const QUrl& type )
  : NepomukFast::Resource( uri, graphUri, type )
{
}

void NepomukFast::InformationElement::setCharacterSets( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#characterSet"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::InformationElement::addCharacterSet( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#characterSet"), Soprano::LiteralValue( value ) );
}

void NepomukFast::InformationElement::setCharacterSet( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#characterSet"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::InformationElement::characterSetUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#characterSet");
}

void NepomukFast::InformationElement::setRootElementOfs( const QList<NepomukFast::DataSource>& value )
{
    for( QList<DataSource>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#rootElementOf"), (*it).uri() );
    }
}

void NepomukFast::InformationElement::addRootElementOf( const NepomukFast::DataSource& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#rootElementOf"), value.uri() );
}

QUrl NepomukFast::InformationElement::rootElementOfUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#rootElementOf");
}

void NepomukFast::InformationElement::setInformationElementDates( const QList<QDateTime>& value )
{
    for( QList<QDateTime>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#informationElementDate"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::InformationElement::addInformationElementDate( const QDateTime& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#informationElementDate"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::InformationElement::informationElementDateUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#informationElementDate");
}

void NepomukFast::InformationElement::setLegals( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#legal"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::InformationElement::addLegal( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#legal"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::InformationElement::legalUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#legal");
}

void NepomukFast::InformationElement::setIsStoredAses( const QList<NepomukFast::DataObject>& value )
{
    for( QList<DataObject>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#isStoredAs"), (*it).uri() );
    }
}

void NepomukFast::InformationElement::addIsStoredAs( const NepomukFast::DataObject& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#isStoredAs"), value.uri() );
}

QUrl NepomukFast::InformationElement::isStoredAsUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#isStoredAs");
}

void NepomukFast::InformationElement::setLanguages( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#language"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::InformationElement::addLanguage( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#language"), Soprano::LiteralValue( value ) );
}

void NepomukFast::InformationElement::setLanguage( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#language"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::InformationElement::languageUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#language");
}

void NepomukFast::InformationElement::setMimeTypes( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#mimeType"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::InformationElement::addMimeType( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#mimeType"), Soprano::LiteralValue( value ) );
}

void NepomukFast::InformationElement::setMimeType( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#mimeType"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::InformationElement::mimeTypeUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#mimeType");
}

void NepomukFast::InformationElement::setVersions( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#version"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::InformationElement::addVersion( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#version"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::InformationElement::versionUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#version");
}

void NepomukFast::InformationElement::setLinkses( const QList<NepomukFast::DataObject>& value )
{
    for( QList<DataObject>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#links"), (*it).uri() );
    }
}

void NepomukFast::InformationElement::addLinks( const NepomukFast::DataObject& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#links"), value.uri() );
}

QUrl NepomukFast::InformationElement::linksUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#links");
}

void NepomukFast::InformationElement::setGenerators( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#generator"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::InformationElement::addGenerator( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#generator"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::InformationElement::generatorUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#generator");
}

void NepomukFast::InformationElement::setDescriptions( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#description"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::InformationElement::addDescription( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#description"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::InformationElement::descriptionUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#description");
}

void NepomukFast::InformationElement::setContentCreateds( const QList<QDateTime>& value )
{
    for( QList<QDateTime>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#contentCreated"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::InformationElement::addContentCreated( const QDateTime& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#contentCreated"), Soprano::LiteralValue( value ) );
}

void NepomukFast::InformationElement::setContentCreated( const QDateTime& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#contentCreated"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::InformationElement::contentCreatedUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#contentCreated");
}

void NepomukFast::InformationElement::setTitles( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#title"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::InformationElement::addTitle( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#title"), Soprano::LiteralValue( value ) );
}

void NepomukFast::InformationElement::setTitle( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#title"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::InformationElement::titleUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#title");
}

void NepomukFast::InformationElement::setContentLastModifieds( const QList<QDateTime>& value )
{
    for( QList<QDateTime>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#contentLastModified"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::InformationElement::addContentLastModified( const QDateTime& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#contentLastModified"), Soprano::LiteralValue( value ) );
}

void NepomukFast::InformationElement::setContentLastModified( const QDateTime& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#contentLastModified"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::InformationElement::contentLastModifiedUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#contentLastModified");
}

void NepomukFast::InformationElement::setKeywords( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#keyword"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::InformationElement::addKeyword( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#keyword"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::InformationElement::keywordUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#keyword");
}

void NepomukFast::InformationElement::setIsLogicalPartOfs( const QList<NepomukFast::InformationElement>& value )
{
    for( QList<InformationElement>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#isLogicalPartOf"), (*it).uri() );
    }
}

void NepomukFast::InformationElement::addIsLogicalPartOf( const NepomukFast::InformationElement& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#isLogicalPartOf"), value.uri() );
}

QUrl NepomukFast::InformationElement::isLogicalPartOfUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#isLogicalPartOf");
}

void NepomukFast::InformationElement::setIdentifiers( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#identifier"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::InformationElement::addIdentifier( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#identifier"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::InformationElement::identifierUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#identifier");
}

void NepomukFast::InformationElement::setPlainTextContents( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#plainTextContent"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::InformationElement::addPlainTextContent( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#plainTextContent"), Soprano::LiteralValue( value ) );
}

void NepomukFast::InformationElement::setPlainTextContent( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#plainTextContent"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::InformationElement::plainTextContentUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#plainTextContent");
}

void NepomukFast::InformationElement::setHtmlContents( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#htmlContent"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::InformationElement::addHtmlContent( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#htmlContent"), Soprano::LiteralValue( value ) );
}

void NepomukFast::InformationElement::setHtmlContent( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#htmlContent"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::InformationElement::htmlContentUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#htmlContent");
}

void NepomukFast::InformationElement::setComments( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#comment"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::InformationElement::addComment( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#comment"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::InformationElement::commentUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#comment");
}

void NepomukFast::InformationElement::setRelatedTos( const QList<NepomukFast::DataObject>& value )
{
    for( QList<DataObject>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#relatedTo"), (*it).uri() );
    }
}

void NepomukFast::InformationElement::addRelatedTo( const NepomukFast::DataObject& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#relatedTo"), value.uri() );
}

QUrl NepomukFast::InformationElement::relatedToUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#relatedTo");
}

void NepomukFast::InformationElement::setContentSizes( const QList<qint64>& value )
{
    for( QList<qint64>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#contentSize"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::InformationElement::addContentSize( const qint64& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#contentSize"), Soprano::LiteralValue( value ) );
}

void NepomukFast::InformationElement::setContentSize( const qint64& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#contentSize"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::InformationElement::contentSizeUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#contentSize");
}

void NepomukFast::InformationElement::setSubjects( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#subject"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::InformationElement::addSubject( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#subject"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::InformationElement::subjectUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#subject");
}

void NepomukFast::InformationElement::setParts( const QList<NepomukFast::DataObject>& value )
{
    for( QList<DataObject>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#hasPart"), (*it).uri() );
    }
}

void NepomukFast::InformationElement::addPart( const NepomukFast::DataObject& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#hasPart"), value.uri() );
}

QUrl NepomukFast::InformationElement::partUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#hasPart");
}

void NepomukFast::InformationElement::setLogicalParts( const QList<NepomukFast::InformationElement>& value )
{
    for( QList<InformationElement>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#hasLogicalPart"), (*it).uri() );
    }
}

void NepomukFast::InformationElement::addLogicalPart( const NepomukFast::InformationElement& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#hasLogicalPart"), value.uri() );
}

QUrl NepomukFast::InformationElement::logicalPartUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#hasLogicalPart");
}

void NepomukFast::InformationElement::setPublishers( const QList<NepomukFast::Contact>& value )
{
    for( QList<Contact>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#publisher"), (*it).uri() );
    }
}

void NepomukFast::InformationElement::addPublisher( const NepomukFast::Contact& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#publisher"), value.uri() );
}

QUrl NepomukFast::InformationElement::publisherUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#publisher");
}

void NepomukFast::InformationElement::setCreators( const QList<NepomukFast::Contact>& value )
{
    for( QList<Contact>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#creator"), (*it).uri() );
    }
}

void NepomukFast::InformationElement::addCreator( const NepomukFast::Contact& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#creator"), value.uri() );
}

QUrl NepomukFast::InformationElement::creatorUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#creator");
}

void NepomukFast::InformationElement::setContributors( const QList<NepomukFast::Contact>& value )
{
    for( QList<Contact>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#contributor"), (*it).uri() );
    }
}

void NepomukFast::InformationElement::addContributor( const NepomukFast::Contact& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#contributor"), value.uri() );
}

QUrl NepomukFast::InformationElement::contributorUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#contributor");
}


