/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#include <soprano/soprano.h>

#include "postaladdress.h"

#include "role.h"

#include <QtCore/QDateTime>
#include <QtCore/QDate>
#include <QtCore/QTime>

NepomukFast::PostalAddress::PostalAddress( const QUrl &uri, const QUrl &graphUri )
  : ContactMedium( uri, graphUri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#PostalAddress", QUrl::StrictMode) )
{
}

NepomukFast::PostalAddress::PostalAddress( const QUrl& uri, const QUrl& graphUri, const QUrl& type )
  : ContactMedium( uri, graphUri, type )
{
}

void NepomukFast::PostalAddress::setRegions( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#region"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::PostalAddress::addRegion( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#region"), Soprano::LiteralValue( value ) );
}

void NepomukFast::PostalAddress::setRegion( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#region"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::PostalAddress::regionUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#region");
}

void NepomukFast::PostalAddress::setCountrys( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#country"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::PostalAddress::addCountry( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#country"), Soprano::LiteralValue( value ) );
}

void NepomukFast::PostalAddress::setCountry( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#country"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::PostalAddress::countryUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#country");
}

void NepomukFast::PostalAddress::setExtendedAddresses( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#extendedAddress"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::PostalAddress::addExtendedAddress( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#extendedAddress"), Soprano::LiteralValue( value ) );
}

void NepomukFast::PostalAddress::setExtendedAddress( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#extendedAddress"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::PostalAddress::extendedAddressUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#extendedAddress");
}

void NepomukFast::PostalAddress::setAddressLocations( const QList<NepomukFast::Resource>& value )
{
    for( QList<Resource>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#addressLocation"), (*it).uri() );
    }
}

void NepomukFast::PostalAddress::addAddressLocation( const NepomukFast::Resource& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#addressLocation"), value.uri() );
}

void NepomukFast::PostalAddress::setAddressLocation( const NepomukFast::Resource& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#addressLocation"), value.uri() );
}

QUrl NepomukFast::PostalAddress::addressLocationUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#addressLocation");
}

void NepomukFast::PostalAddress::setStreetAddresses( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#streetAddress"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::PostalAddress::addStreetAddress( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#streetAddress"), Soprano::LiteralValue( value ) );
}

void NepomukFast::PostalAddress::setStreetAddress( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#streetAddress"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::PostalAddress::streetAddressUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#streetAddress");
}

void NepomukFast::PostalAddress::setPostalcodes( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#postalcode"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::PostalAddress::addPostalcode( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#postalcode"), Soprano::LiteralValue( value ) );
}

void NepomukFast::PostalAddress::setPostalcode( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#postalcode"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::PostalAddress::postalcodeUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#postalcode");
}

void NepomukFast::PostalAddress::setLocalitys( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#locality"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::PostalAddress::addLocality( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#locality"), Soprano::LiteralValue( value ) );
}

void NepomukFast::PostalAddress::setLocality( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#locality"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::PostalAddress::localityUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#locality");
}

void NepomukFast::PostalAddress::setPoboxs( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#pobox"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::PostalAddress::addPobox( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#pobox"), Soprano::LiteralValue( value ) );
}

void NepomukFast::PostalAddress::setPobox( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#pobox"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::PostalAddress::poboxUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#pobox");
}


